/**
 */
package de.hftstuttgart.cityunits.model.quantities;

import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.hftstuttgart.cityunits.model.quantities.QuantitiesFactory
 * @model kind="package"
 * @generated
 */
public interface QuantitiesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "quantities";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "https://www.hftstuttgart.de/quantities";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "quant";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	QuantitiesPackage eINSTANCE = de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl.init();

	/**
	 * The meta object id for the '<em>Quantity Double</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.cityunits.model.NullableQuantity
	 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getQuantityDouble()
	 * @generated
	 */
	int QUANTITY_DOUBLE = 0;

	/**
	 * The meta object id for the '<em>Quantity Long</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.hftstuttgart.cityunits.model.NullableQuantity
	 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getQuantityLong()
	 * @generated
	 */
	int QUANTITY_LONG = 1;


	/**
	 * The meta object id for the '<em>Fraction</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.Double
	 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getFraction()
	 * @generated
	 */
	int FRACTION = 2;


	/**
	 * Returns the meta object for data type '{@link de.hftstuttgart.cityunits.model.NullableQuantity <em>Quantity Double</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Quantity Double</em>'.
	 * @see de.hftstuttgart.cityunits.model.NullableQuantity
	 * @model instanceClass="de.hftstuttgart.cityunits.model.NullableQuantity"
	 * @generated
	 */
	EDataType getQuantityDouble();

	/**
	 * Returns the meta object for data type '{@link de.hftstuttgart.cityunits.model.NullableQuantity <em>Quantity Long</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Quantity Long</em>'.
	 * @see de.hftstuttgart.cityunits.model.NullableQuantity
	 * @model instanceClass="de.hftstuttgart.cityunits.model.NullableQuantity"
	 * @generated
	 */
	EDataType getQuantityLong();

	/**
	 * Returns the meta object for data type '{@link java.lang.Double <em>Fraction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Fraction</em>'.
	 * @see java.lang.Double
	 * @model instanceClass="java.lang.Double"
	 *        extendedMetaData="minInclusive='0.0' maxInclusive='1.0'"
	 * @generated
	 */
	EDataType getFraction();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	QuantitiesFactory getQuantitiesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '<em>Quantity Double</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.cityunits.model.NullableQuantity
		 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getQuantityDouble()
		 * @generated
		 */
		EDataType QUANTITY_DOUBLE = eINSTANCE.getQuantityDouble();

		/**
		 * The meta object literal for the '<em>Quantity Long</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.hftstuttgart.cityunits.model.NullableQuantity
		 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getQuantityLong()
		 * @generated
		 */
		EDataType QUANTITY_LONG = eINSTANCE.getQuantityLong();

		/**
		 * The meta object literal for the '<em>Fraction</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.Double
		 * @see de.hftstuttgart.cityunits.model.quantities.impl.QuantitiesPackageImpl#getFraction()
		 * @generated
		 */
		EDataType FRACTION = eINSTANCE.getFraction();

	}

} //QuantitiesPackage
